/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * RedoAction.cpp
 *
 *  Created on: Oct 27, 2010
 *      Author: heber
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include "ActionQueue.hpp"

#include <iostream>

#include "CodePatterns/Assert.hpp"

using namespace MoleCuilder;

#include "Actions/RedoAction.hpp"

// and construct the stuff
#include "RedoAction.def"
#include "Action_impl_pre.hpp"

/** =========== define the function ====================== */
ActionState::ptr RedoAction::performCall(){
  std::cout << "Redo" << std::endl;
  ActionQueue::getInstance().redoLast();
  return Action::success;
}

ActionState::ptr RedoAction::performUndo(ActionState::ptr){
  ASSERT(0,"Cannot undo a redo (should use undo for this");
  return Action::success;
}

ActionState::ptr RedoAction::performRedo(ActionState::ptr){
  ASSERT(0,"Cannot redo a redo");
  return Action::success;
}

bool RedoAction::canUndo(){
  return false;
}

bool RedoAction::shouldUndo(){
  return false;
}
/** =========== end of function ====================== */
